#include <cstdlib>
#include <iostream>
#include <string>

#include <SDL.h>
#include <SDL_ttf.h>

#include "Jeu/jeu.h"
#include "Menu/menu.h"

///Main.cpp
///Date de modification: 29_09_2013
///Objet: finir le menu.cpp pour l'utiliser correctement ici
///Prochaine étape:

/*
-Rôle de main.cpp:
        Ce main géneral permet d'interphaser les sequences de jeu et de menu. Il permet également
    l'ouverture et la fermeture des bibliothèques SDL et TTF.

-Fichiers inclus:
	+jeu.h:
		Permet de lancer le jeu avec les infos reçues par le menu.
    +menu.h:
		Permet d'obtenir les informations au lancement du jeu (niveau selectionné).
*/

int main ( int argc, char** argv )
{
    /// [1] Démarrage
    // [1.1] Démarrages SDL et TTF
    if ( SDL_Init( SDL_INIT_VIDEO ) < 0 || TTF_Init() < 0 )
    {
        std::cout << "Impossible d'initialiser la SDL: " << SDL_GetError() << std::endl;
        std::cout << "Ou problème de TTf: " << TTF_GetError() << std::endl;
        return 1;
    }

    // [1.2] Préparation de fermeture
    atexit(SDL_Quit);
    atexit(TTF_Quit);

    /// [2] Alternance jeu et menu
    std::string choix;

    do
    {
        choix = menu();
        if (choix=="quitter")
            break;
    }while(jeu(choix));


    /// [3] Destruction des composants
    //rien à détruire

    std::cout << "Main.cpp: Aucune erreur détectée." << std::endl;
    return 0;
}
